schedule function bedrock_golem:1t 1t

#BOSSBAR
execute as @e[type=iron_golem,tag=bedrock_golem.entity,limit=1] at @s run function bedrock_golem:bossbar

#KILL ENEMIES
execute as @e[type=iron_golem,tag=bedrock_golem.entity,predicate=!bedrock_golem:angry] at @s run execute if entity @e[predicate=bedrock_golem:angryat,distance=..64] run data modify entity @s AngryAt set from entity @e[predicate=bedrock_golem:angryat,sort=nearest,limit=1] UUID

#BEDROCK GOLEM NAMETAG
execute as @e[type=iron_golem,name=!"Bedrock Golem",tag=bedrock_golem.entity] at @s run data merge entity @s {CustomName:'{"text":"Bedrock Golem","color":"gray"}'}
execute as @e[type=iron_golem,name="Bedrock Golem",tag=!bedrock_golem.entity] at @s run data merge entity @s {CustomName:'{"text":"Bedrock golem"}'}

#BEDROCK GOLEM SPAWN EGG
execute as @e[type=area_effect_cloud,tag=bedrock_golem.spawn] at @s run function summon:bedrock_golem
kill @e[type=area_effect_cloud,tag=bedrock_golem.spawn]

#PLAYERCREATED TRUE
execute unless score bedrock_golem.sc bedrock_golem.b matches 1 run execute unless score bedrock_golem.sc bedrock_golem.b matches 2 run execute as @e[type=iron_golem,tag=bedrock_golem.entity,nbt=!{PlayerCreated:1b}] at @s run data merge entity @s {PlayerCreated:1b}

#PLAYERCREATED FALSE
execute if score bedrock_golem.sc bedrock_golem.b matches 1 run execute as @e[type=iron_golem,tag=bedrock_golem.entity,nbt=!{PlayerCreated:0b}] at @s run data merge entity @s {PlayerCreated:0b}
execute if score bedrock_golem.sc bedrock_golem.b matches 2 run execute as @e[type=iron_golem,tag=bedrock_golem.entity,nbt=!{PlayerCreated:0b}] at @s run data merge entity @s {PlayerCreated:0b}

#TEAM JOIN PLAYER
execute unless score bedrock_golem.sc bedrock_golem.b matches 2 run team join player @e[type=iron_golem,tag=bedrock_golem.entity,team=!player]

#TEAM LEAVE PLAYER
execute if score bedrock_golem.sc bedrock_golem.b matches 2 run team leave @e[type=iron_golem,tag=bedrock_golem.entity,team=player]

#VG.PROTECTED ADD
execute if score bedrock_golem.sc bedrock_golem.b matches 1 run tag @e[type=iron_golem,tag=bedrock_golem.entity,tag=!vg.protected] add vg.protected

#VG.PROTECTED REMOVE
execute unless score bedrock_golem.sc bedrock_golem.b matches 1 run tag @e[type=iron_golem,tag=bedrock_golem.entity,tag=vg.protected] remove vg.protected

#BEHAVIOUR HOSTILE TO PLAYER
execute if score bedrock_golem.sc bedrock_golem.b matches 2 run execute as @e[type=iron_golem,tag=bedrock_golem.entity,predicate=!bedrock_golem:angry] at @s run execute if entity @a[gamemode=!creative,gamemode=!spectator,distance=..16] run data modify entity @s AngryAt set from entity @p[gamemode=!creative,gamemode=!spectator] UUID

#BEHAVIOUR HOSTILE TO IRON GOLEM
execute if score bedrock_golem.sc bedrock_golem.b matches 2 run execute as @e[type=iron_golem,tag=bedrock_golem.entity,predicate=!bedrock_golem:angry] at @s run execute if entity @e[type=#bedrock_golem:hostile_haters,tag=!bedrock_golem.entity,tag=!smithed.block,nbt=!{Invulnerable:1b},distance=..16] run data modify entity @s AngryAt set from entity @e[type=#bedrock_golem:hostile_haters,tag=!bedrock_golem.entity,tag=!smithed.block,nbt=!{Invulnerable:1b},limit=1,sort=nearest] UUID

#BEHAVIOUR HOSTILE FROM IRON GOLEM
execute if score bedrock_golem.sc bedrock_golem.b matches 2 run execute as @e[type=iron_golem,tag=!bedrock_golem.entity,tag=!smithed.entity,predicate=!bedrock_golem:angry] at @s run execute if entity @e[type=iron_golem,tag=bedrock_golem.entity,nbt=!{Invulnerable:1b},distance=..16] run data modify entity @s AngryAt set from entity @e[type=iron_golem,tag=bedrock_golem.entity,nbt=!{Invulnerable:1b},limit=1,sort=nearest] UUID

#SLOW DOWN MOBS
execute as @e[type=iron_golem,tag=bedrock_golem.entity,predicate=bedrock_golem:angry] at @s run execute as @e[type=!player,predicate=bedrock_golem:angryat,distance=..3] at @s run function bedrock_golem:slow_down

#CLEAR EFFECTS
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] bad_omen
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] blindness
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] hunger
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] instant_damage
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] levitation
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] mining_fatigue
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] poison
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] slow_falling
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] slowness
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] unluck
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] weakness
effect clear @e[type=iron_golem,tag=bedrock_golem.entity] wither